package rule;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class FleeJump extends Rule {

	public FleeJump(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {
		return gameState.getCommandCenter().getDistanceX() < 400;
	}

	@Override
	public void execute() {
		jumpFlee();
	}

	private void jumpFlee() {
		String jumpLeft, jumpRight;
		if (gameState.getMyCharacterData().isFront()) {
			jumpLeft = "BACK_JUMP";
			jumpRight = "FOR_JUMP";
		} else {
			jumpRight = "BACK_JUMP";
			jumpLeft = "FOR_JUMP";
		}

		if (Math.abs(gameState.getMyCharacterData().getX()
				- gameState.getEnemyCharacterData().getX()) > 300) {
			gameState.getCommandCenter().commandCall("JUMP");
		}

		if (gameState.getMyCharacterData().getX() < 300) {
			// jump away from left wall
			gameState.getCommandCenter().commandCall(jumpRight);
		} else if (gameState.getMyCharacterData().getX() > gameState
				.getGameData().getStageXMax() - 300) {
			// jump away from right wall
			gameState.getCommandCenter().commandCall(jumpLeft);
		} else if (gameState.getMyCharacterData().getX() < gameState
				.getEnemyCharacterData().getX()) {
			// jump away from enemy
			gameState.getCommandCenter().commandCall(jumpLeft);
		} else {
			// jump away from enemy
			gameState.getCommandCenter().commandCall(jumpRight);
		}
	}

	@Override
	public int getPriority() {
		return 3;
	}
}
