package rule;

import enumerate.Action;
import enumerate.State;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class PermanentDiagonalFireball extends Rule {

	public PermanentDiagonalFireball(GameStateInterface gameState) {
		super(gameState, true);
	}

	@Override
	public boolean satisfied() {
		return (gameState.getMyCharacterData().getState() != State.DOWN);
	}

	@Override
	public void execute() {
		if (((gameState.getMyCharacterData().getAction() == Action.STAND_D_DF_FB) || (gameState
				.getMyCharacterData().getAction() == Action.STAND_F_D_DFA))
				&& (gameState.getMyCharacterData().getRemainingFrame() < 30)) {
			// diagonal fireball
			gameState.getCommandCenter().commandCall("STAND_D_DF_FB");
		} else {
			// uppercut
			gameState.getCommandCenter().commandCall("STAND_F_D_DFA");
		}
	}

	@Override
	public int getPriority() {
		return -1;
	}

}
