package rule;

import enumerate.State;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class PermanentHardAirPunch2 extends Rule {

	public PermanentHardAirPunch2(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {

		return true;

	}

	@Override
	public void execute() {

		if ((gameState.getMyCharacterData().getState() == State.AIR)
				&& (gameState.getMyCharacterData().getSpeedY() < 0)) {
			execCounter();
		} else {
			execDodge();
		}

	}

	private void execCounter() {
		gameState.getCommandCenter().commandCall("AIR_D_DB_BB");
	}

	private void execDodge() {
		String jumpLeft, jumpRight;
		if (gameState.getMyCharacterData().isFront()) {
			jumpLeft = "BACK_JUMP";
			jumpRight = "FOR_JUMP";
		} else {
			jumpRight = "BACK_JUMP";
			jumpLeft = "FOR_JUMP";
		}

		if (gameState.getMyCharacterData().getX() < (gameState.getGameData()
				.getStageXMax() / 2)) {
			// jump away from left wall
			gameState.getCommandCenter().commandCall(jumpRight);
		} else {
			// jump away from right wall
			gameState.getCommandCenter().commandCall(jumpLeft);
		}
	}

	@Override
	public int getPriority() {
		return 2;
	}

}
