package rule;

import enumerate.Action;
import enumerate.State;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class SlideSlideCombo extends Rule {

	public SlideSlideCombo(GameStateInterface gameState) {
		super(gameState, true);
	}

	@Override
	public boolean satisfied() {
		return (gameState.getMyCharacterData().getAction() == Action.STAND_D_DB_BB)
				&& (gameState.getEnemyCharacterData().getState() != State.AIR)
				&& (gameState.getMyCharacterData().getState() != State.DOWN);
	}

	@Override
	public void execute() {
		// weaker form of permanent slide
		gameState.getCommandCenter().commandCall("2 1 4 _ B");
	}

	@Override
	public int getPriority() {
		return -1;
	}

}
