package FuzzySystem;

import java.util.ArrayList;

public class LinguisticList {
	ArrayList<LinguisticVariable> lingVars = new ArrayList<LinguisticVariable>();
	
	MemberGraph temp;
	
	public LinguisticList graph(MemberGraph graph)
	{
		this.temp = graph;
		return this;
	}
	
	public void clear(double value)
	{
		for(LinguisticVariable var : lingVars)
			var.value = value;
	}
	
	public LinguisticList add(LinguisticVariable var)
	{
		lingVars.add(var);
		return this;
	}
	
	public LinguisticList add(String name)
	{
		lingVars.add(new LinguisticVariable(name,temp));
		return this;
	}
	
	public void addAll(LinguisticList list)
	{
		lingVars.addAll(list.lingVars);
	}
	
	public LinguisticVariable get(String name)
	{
		for(LinguisticVariable var : lingVars)
			if(var.name.equals(name))
				return var;
		return null;
	}
}
